"use strict";
var __assign = (this && this.__assign) || function () {
    __assign = Object.assign || function(t) {
        for (var s, i = 1, n = arguments.length; i < n; i++) {
            s = arguments[i];
            for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
                t[p] = s[p];
        }
        return t;
    };
    return __assign.apply(this, arguments);
};
Object.defineProperty(exports, "__esModule", { value: true });
var defaultOptions = {
    collapse: true,
    show: true,
};
var formatTitle = function (logs) {
    var action = logs.action, response = logs.response;
    var actionType = action.id || action.endpoint;
    var titleName = response ? 'Response' : 'Request';
    var titleCSS = ["color: " + (response && response.error ? 'red' : 'gray'), 'color: gray; font-weight: normal'];
    var title = ["%c " + titleName + " %c " + actionType].concat(titleCSS);
    var simpleTitle = titleName + " " + actionType;
    return { title: title, simpleTitle: simpleTitle };
};
exports.createLogger = function (options) { return function (logs) {
    var loggerOptions = __assign({}, defaultOptions, options);
    if (loggerOptions.show) {
        var _a = formatTitle(logs), title = _a.title, simpleTitle = _a.simpleTitle;
        try {
            if (loggerOptions.collapse) {
                console.groupCollapsed.apply(console, title);
            }
            else {
                console.group.apply(console, title);
            }
        }
        catch (e) {
            console.log(simpleTitle);
        }
        Object.keys(logs).forEach(function (key) {
            console.log("%c " + key, 'font-weight: bold', logs[key]);
        });
        try {
            console.groupEnd();
        }
        catch (e) {
            console.log('-- END --');
        }
    }
}; };
